---
id: 65ef1dd722f6e7c8294eeec4
title: Step 19
challengeType: 20
dashedName: step-19
---

# --description--

Finally, return the value of `root` from the `square_root_bisection` function.

# --hints--

You should return `root` at the end of the function.

```js
({ 
    test: () => 
    {
        const pyClassStr = runPython(`str(_Node(_code).find_function("square_root_bisection"))`);
        assert.match(pyClassStr, /return\s*root/)
    }
})
```

# --seed--

## --seed-contents--

```py
def square_root_bisection(square_target, tolerance=1e-7, max_iterations=100):
    if square_target < 0:
        raise ValueError('Square root of negative number is not defined in real numbers')
    if square_target == 1:
        root = 1
        print(f'The square root of {square_target} is 1')
    elif square_target == 0:
        root = 0
        print(f'The square root of {square_target} is 0')

    else:
        low = 0
        high = max(1, square_target)
        root = None
        
        for _ in range(max_iterations):
            mid = (low + high) / 2
            square_mid = mid**2

            if abs(square_mid - square_target) < tolerance:
                root = mid
                break

            elif square_mid < square_target:
                low = mid
            else:
                high = mid

--fcc-editable-region--
        if root is None:
            print(f"Failed to converge within {max_iterations} iterations.")
        
        else:   
            print(f'The square root of {square_target} is approximately {root}')
  
--fcc-editable-region--

```
